//***************************************************************************
//  Genetic Algorithm Viewer 1.0
//    26/5/2000
//
//  This program uses a GA to find a Biomorph Genome
//    Jean-Philippe Rennard May 2000
//    alife@rennard.org
//    http://www.rennard.org/alife
//
//    This program is free software; you can redistribute it and/or
//    modify it under the terms of the GNU General Public License
//    as published by the Free Software Foundation.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//***************************************************************************
package Gav;

import java.awt.*;
import java.util.*;
//***************************************************************************
//      Def of abstract Living Entity (Biots)
//***************************************************************************
/** Defines the different Types of Biots */
class CBiotType
{
  static final String Type[]={"Biomorph"};
}
/** CBiot : Abstract Living Entity class. Defines the common
living properties and methods **/
abstract class CBiot
{
  /** Pointer to living entity universe **/
  public CUniverse MyUniverse;

  /** Selection type */
  public int Selected=0;

  private double EnergyLevel;
  int Direction;
  PosReal Position=new PosReal();
  
  public CBiot() {
  }
  /** Creates a Biot in a Universe **/
  public CBiot(CUniverse univ) {
    MyUniverse=univ;
  }
  /** Universe getter */
  public CUniverse GetMyUniverse() {
    return(MyUniverse);
  }
  /** Type of entity manager */
  CBiotType MyType;
  public CBiotType GetMyType() {
    return(MyType);
  }
  public void SetBiotType(CBiotType t) {
    MyType=t;
  }
  public double GetEnergyLevel() {
    return(EnergyLevel);
  }
  //
  abstract void Live(JPView v);

}
/** CGenome : Genome defined as an Object Collection */ 
class CGenome extends Vector
{
  public CGenome(int nbgene) {
    for(int i=0;i<nbgene;i++) {
      this.addElement(null);
    }
  }
}


