//***************************************************************************
//  Genetic Algorithm Viewer 1.0
//    26/5/2000
//
//  This program uses a GA to find a Biomorph Genome
//    Jean-Philippe Rennard May 2000
//    alife@rennard.org
//    http://www.rennard.org/alife
//
//    This program is free software; you can redistribute it and/or
//    modify it under the terms of the GNU General Public License
//    as published by the Free Software Foundation.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//***************************************************************************
package Gav;

import java.awt.*;
import java.awt.event.*;

/** Draw a fitness gauge */
public class CFitView extends JPView {

  public CFitView(Color c) {
    super(c);
  }

  public void ClearBkg() {
    super.ClearBkg();
    repaint();
  }

  void DrawFitness(double percent) {
    // creates an integer with the first decimal
    double base=percent*10.0;
    long b2=Math.round(base);
    if(b2>base)
      b2 -= 1;
    // set color according to it
    switch((int)b2) {
      case 6:
        GrBuff.setColor(Color.green);
      break;
      case 7:
        GrBuff.setColor(Color.yellow);
      break;
      case 8:
        GrBuff.setColor(Color.blue);
      break;
      case 9:
      case 10:
        GrBuff.setColor(Color.red);
      break;
      default:
        GrBuff.setColor(Color.white);
    }
    double p2;
    if(b2<10)
      p2=(percent-(b2/10.0))*10;
    else
      p2=1.0;

    GrBuff.fillRect(0,0,(int)(p2*Width),Height);
    GrBuff.setColor(Color.white);
    GrBuff.fillRect((int)Math.round(p2*Width)+1,0,Width,Height);
    repaint();
  }
}