//***************************************************************************
//  Genetic Algorithm Viewer 1.0
//    26/5/2000
//
//  This program uses a GA to find a Biomorph Genome
//    Jean-Philippe Rennard May 2000
//    alife@rennard.org
//    http://www.rennard.org/alife
//
//    This program is free software; you can redistribute it and/or
//    modify it under the terms of the GNU General Public License
//    as published by the Free Software Foundation.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//***************************************************************************
package Gav;

import java.awt.*;
import java.awt.event.*;
import java.util.*;

/** User Interface */
public class CGavApp extends Frame {
  /**Graphic tools */
  JPGraphTools GrTools=new JPGraphTools(0,0,JPGraphTools.REPRANISOTROPIC);// .REPRBASE);
  public Gav MotherApplet;
  CGavUniverse World;
  int CurrentGrid;
  /** Mutation rate parameter */
  int ParamMr;
  /** Language management */
  CText Texts;
  // UI def
  Panel panel1 = new Panel();
  Panel panel3 = new Panel();
  Button ButtonRandom = new Button();
  Button ButtonGo = new Button();
  Button ButtonAbout = new Button();
  GridLayout gridLayout2 = new GridLayout();
  GridLayout gridLayout1 = new GridLayout();
  Label label4 = new Label();
  Label label6 = new Label();
  Panel panel4 = new Panel();
  Checkbox CbScaleLinear = new Checkbox();
  Checkbox CbScaleWindow = new Checkbox();
  Checkbox CbScaleExpo = new Checkbox();
  CheckboxGroup checkboxGroup1 = new CheckboxGroup();
  Panel panel6 = new Panel();
  Panel panel7 = new Panel();
  GridLayout gridLayout6 = new GridLayout();
  Checkbox CbNoScaling = new Checkbox();
  Panel panel5 = new Panel();
  GridLayout gridLayout4 = new GridLayout();
  Checkbox CbElitist = new Checkbox();
  Checkbox CbMutateGene = new Checkbox();
  Panel panel9 = new Panel();
  GridLayout gridLayout8 = new GridLayout();
  Panel PanDispGen1 = new Panel();
  GridLayout gridLayout9 = new GridLayout();
  Panel PanDispGen3 = new Panel();
  GridLayout gridLayout10 = new GridLayout();
  Panel PanDispGen2 = new Panel();
  GridLayout gridLayout11 = new GridLayout();
  TextField MutationRate = new TextField();
  Panel PanDispMaxFit = new Panel();
  Panel PanDispAvgFit = new Panel();
  Label FitBestGene = new Label();
  GridLayout gridLayout3 = new GridLayout();
  GridLayout gridLayout12 = new GridLayout();
  Button ButtonStep = new Button();
  Choice ChoiceSpeed = new Choice();
  Label Lab = new Label();
  GridLayout gridLayout13 = new GridLayout();
  Panel panel2 = new Panel();
  Button ButtonGridPlus = new Button();
  Button ButtonGridLess = new Button();
  GridLayout gridLayout14 = new GridLayout();
  Choice ChoicePop = new Choice();
  GridLayout gridLayout5 = new GridLayout();
  Button ButtonGrid0 = new Button();
  Panel panel10 = new Panel();
  Panel panel12 = new Panel();
  Panel PanDispBitGen1 = new Panel();
  GridLayout gridLayout7 = new GridLayout();
  Panel PanDispBitGen2 = new Panel();
  Label FitAvgGene = new Label();
  GridLayout gridLayout15 = new GridLayout();
  GridLayout gridLayout16 = new GridLayout();
  GridLayout gridLayout17 = new GridLayout();
  Panel panel8 = new Panel();
  Panel panel11 = new Panel();
  GridLayout gridLayout19 = new GridLayout();
  Panel panel15 = new Panel();
  GridLayout gridLayout20 = new GridLayout();
  GridLayout gridLayout18 = new GridLayout();
  Panel panel16 = new Panel();
  Button ButtonDefault = new Button();
  GridLayout gridLayout21 = new GridLayout();
  Checkbox CbScaleLinear2 = new Checkbox();
  Panel panel13 = new Panel();
  GridLayout gridLayout22 = new GridLayout();
  Panel panel14 = new Panel();
  GridLayout gridLayout23 = new GridLayout();
  Label LabTextOut = new Label();
  BorderLayout borderLayout1 = new BorderLayout();
  Label label1 = new Label();
  Label Gen = new Label();
  Checkbox CbMutateBit = new Checkbox();
  CheckboxGroup checkboxGroup2 = new CheckboxGroup();
  Checkbox CbCalcTypeGeno = new Checkbox();
  Checkbox CbCalcTypePheno = new Checkbox();
  CheckboxGroup checkboxGroup3 = new CheckboxGroup();

  /** Creates a GAV App in applet with language. */
  public CGavApp(Gav ma,int lang) {
    super(ma.GetName()+" "+ma.GetAuthor());
    MotherApplet=ma;
    Texts=new CText(lang);
    try  {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  /** Init Gav App : Creates interface and implements a World */
  private void jbInit() throws Exception {
    setLayout(borderLayout1);
    panel1.setBackground(Color.white);
    panel1.setLayout(gridLayout2);
    this.addComponentListener(new java.awt.event.ComponentAdapter() {
      public void componentResized(ComponentEvent e) {
        this_componentResized(e);
      }
    });
    panel3.setBackground(SystemColor.control);
    panel3.setLayout(gridLayout1);
    ButtonRandom.setLabel(Texts.Txt[0]);
    ButtonRandom.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        ButtonRandom_actionPerformed(e);
      }
    });
    ButtonGo.setActionCommand(Texts.Txt[2]);
    ButtonGo.setLabel(Texts.Txt[2]);
    ButtonGo.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        ButtonGo_actionPerformed(e);
      }
    });

    ButtonAbout.setLabel(Texts.Txt[3]);
    ButtonAbout.addMouseListener(new java.awt.event.MouseAdapter() {

      public void mouseClicked(MouseEvent e) {
        ButtonAbout_mouseClicked(e);
      }
    });
    this.addWindowListener(new java.awt.event.WindowAdapter() {

      public void windowClosing(WindowEvent e) {
        this_windowClosing(e);
      }
    });
    label4.setBackground(Color.gray);
    label4.setText(Texts.Txt[4]);
    label6.setBackground(Color.gray);
    label6.setText(Texts.Txt[5]);
    panel4.setBackground(Color.gray);
    panel4.setLayout(gridLayout5);
    CbScaleLinear.setBackground(SystemColor.control);
    CbScaleLinear.setCheckboxGroup(checkboxGroup1);
    CbScaleLinear.setLabel(Texts.Txt[6]);
    CbScaleLinear.setState(true);
    CbScaleLinear.addItemListener(new java.awt.event.ItemListener() {

      public void itemStateChanged(ItemEvent e) {
        CbScaleLinear_itemStateChanged(e);
      }
    });
    CbScaleWindow.setBackground(SystemColor.control);
    CbScaleWindow.setCheckboxGroup(checkboxGroup1);
    CbScaleWindow.setLabel(Texts.Txt[7]);
    CbScaleWindow.addItemListener(new java.awt.event.ItemListener() {

      public void itemStateChanged(ItemEvent e) {
        CbScaleWindow_itemStateChanged(e);
      }
    });
    CbScaleExpo.setBackground(SystemColor.control);
    CbScaleExpo.setCheckboxGroup(checkboxGroup1);
    CbScaleExpo.setLabel(Texts.Txt[8]);
    CbScaleExpo.addItemListener(new java.awt.event.ItemListener() {

      public void itemStateChanged(ItemEvent e) {
        CbScaleExpo_itemStateChanged(e);
      }
    });
    panel6.setLayout(gridLayout13);
    panel7.setLayout(gridLayout6);
    gridLayout6.setColumns(1);
    gridLayout6.setRows(5);
    CbNoScaling.setBackground(SystemColor.control);
    CbNoScaling.setCheckboxGroup(checkboxGroup1);
    CbNoScaling.setLabel(Texts.Txt[9]);
    CbNoScaling.addItemListener(new java.awt.event.ItemListener() {

      public void itemStateChanged(ItemEvent e) {
        CbNoScaling_itemStateChanged(e);
      }
    });
    panel5.setLayout(gridLayout4);
    gridLayout4.setColumns(1);
    gridLayout4.setRows(5);
    CbElitist.setBackground(Color.gray);
    CbElitist.setLabel(Texts.Txt[10]);
    CbElitist.addItemListener(new java.awt.event.ItemListener() {

      public void itemStateChanged(ItemEvent e) {
        CbElitist_itemStateChanged(e);
      }
    });
    CbMutateGene.setBackground(Color.gray);
    CbMutateGene.setCheckboxGroup(checkboxGroup3);
    CbMutateGene.setLabel(Texts.Txt[11]);
    CbMutateGene.addItemListener(new java.awt.event.ItemListener() {

      public void itemStateChanged(ItemEvent e) {
        CbMutateGene_itemStateChanged(e);
      }
    });
    panel5.setBackground(SystemColor.control);
    panel6.setBackground(SystemColor.control);
    panel9.setLayout(gridLayout8);
    gridLayout8.setColumns(1);
    gridLayout8.setRows(3);
    panel9.setBackground(SystemColor.control);
    PanDispGen1.setBackground(Color.white);
    PanDispGen1.setLayout(gridLayout9);
    PanDispGen3.setLayout(gridLayout10);
    PanDispGen3.setBackground(Color.white);
    PanDispGen2.setLayout(gridLayout11);
    PanDispGen2.setBackground(Color.white);
    FitBestGene.setBackground(Color.white);
    FitBestGene.setFont(new java.awt.Font("Monospaced", 0, 12));
    FitBestGene.setAlignment(1);
    PanDispAvgFit.setBackground(SystemColor.control);
    PanDispAvgFit.setLayout(gridLayout12);
    PanDispMaxFit.setLayout(gridLayout3);
    panel7.setBackground(SystemColor.control);
    ButtonStep.setLabel(Texts.Txt[12]);
    ButtonStep.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        ButtonStep_actionPerformed(e);
      }
    });
    ChoiceSpeed.addItemListener(new java.awt.event.ItemListener() {

      public void itemStateChanged(ItemEvent e) {
        ChoiceSpeed_itemStateChanged(e);
      }
    });
    Lab.setText(Texts.Txt[13]);
    Lab.setBackground(Color.gray);
    gridLayout13.setColumns(1);
    gridLayout13.setRows(4);
    ButtonGridPlus.setLabel(Texts.Txt[14]);
    ButtonGridPlus.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        ButtonGridPlus_actionPerformed(e);
      }
    });
    ButtonGridLess.setLabel(Texts.Txt[15]);
    ButtonGridLess.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        ButtonGridLess_actionPerformed(e);
      }
    });
    panel2.setLayout(gridLayout14);
    gridLayout5.setColumns(2);
    gridLayout5.setRows(4);
    ChoicePop.addItemListener(new java.awt.event.ItemListener() {

      public void itemStateChanged(ItemEvent e) {
        ChoicePop_itemStateChanged(e);
      }
    });
    ButtonGrid0.setLabel("0");
    ButtonGrid0.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        ButtonGrid0_actionPerformed(e);
      }
    });
    panel10.setLayout(gridLayout7);
    gridLayout7.setColumns(2);
    panel12.setLayout(gridLayout15);
    PanDispBitGen1.setLayout(gridLayout16);
    PanDispBitGen2.setLayout(gridLayout17);
    panel8.setLayout(gridLayout18);
    panel11.setLayout(gridLayout19);
    gridLayout19.setColumns(2);
    gridLayout19.setRows(2);
    panel15.setLayout(gridLayout20);
    gridLayout20.setColumns(1);
    gridLayout20.setRows(2);
    FitAvgGene.setBackground(Color.white);
    FitAvgGene.setFont(new java.awt.Font("Monospaced", 0, 12));
    FitAvgGene.setAlignment(1);
    ButtonDefault.setLabel(Texts.Txt[16]);
    ButtonDefault.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        ButtonDefault_actionPerformed(e);
      }
    });
    panel16.setLayout(gridLayout21);
    gridLayout21.setColumns(2);
    gridLayout14.setColumns(3);
    gridLayout1.setColumns(5);
    CbScaleLinear2.addItemListener(new java.awt.event.ItemListener() {

      public void itemStateChanged(ItemEvent e) {
        CbScaleLinear2_itemStateChanged(e);
      }
    });
    CbScaleLinear2.setLabel(Texts.Txt[17]);
    CbScaleLinear2.setCheckboxGroup(checkboxGroup1);
    CbScaleLinear2.setBackground(SystemColor.control);
    panel13.setLayout(gridLayout22);
    gridLayout22.setRows(2);
    panel14.setLayout(gridLayout23);
    label1.setText(Texts.Txt[18]);
    CbMutateBit.addItemListener(new java.awt.event.ItemListener() {

      public void itemStateChanged(ItemEvent e) {
        CbMutateBit_itemStateChanged(e);
      }
    });
    CbMutateBit.setLabel(Texts.Txt[19]);
    CbMutateBit.setBackground(Color.gray);
    CbMutateBit.setCheckboxGroup(checkboxGroup3);
    CbCalcTypeGeno.addItemListener(new java.awt.event.ItemListener() {

      public void itemStateChanged(ItemEvent e) {
        CbCalcTypeGeno_itemStateChanged(e);
      }
    });
    CbCalcTypeGeno.setLabel(Texts.Txt[20]);
    CbCalcTypeGeno.setCheckboxGroup(checkboxGroup2);
    CbCalcTypeGeno.setBackground(SystemColor.control);
    CbCalcTypePheno.addItemListener(new java.awt.event.ItemListener() {

      public void itemStateChanged(ItemEvent e) {
        CbCalcTypePheno_itemStateChanged(e);
      }
    });
    CbCalcTypePheno.setLabel(Texts.Txt[21]);
    CbCalcTypePheno.setCheckboxGroup(checkboxGroup2);
    CbCalcTypePheno.setBackground(SystemColor.control);
    MutationRate.setBackground(Color.white);
    this.add(panel1, BorderLayout.CENTER);
    this.add(panel6, BorderLayout.WEST);
    panel6.add(panel4, null);
    panel4.add(label4, null);
    panel4.add(ChoicePop, null);
    panel4.add(label6, null);
    panel4.add(MutationRate, null);
    panel4.add(label1, null);
    panel4.add(ChoiceSpeed, null);
    panel4.add(Lab, null);
    panel4.add(Gen, null);
    panel6.add(panel7, null);
    panel7.add(CbScaleWindow, null);
    panel7.add(CbScaleExpo, null);
    panel7.add(CbScaleLinear, null);
    panel7.add(CbScaleLinear2, null);
    panel7.add(CbNoScaling, null);
    panel6.add(panel5, null);
    panel5.add(CbElitist, null);
    panel5.add(CbCalcTypePheno, null);
    panel5.add(CbCalcTypeGeno, null);
    panel5.add(CbMutateBit, null);
    panel5.add(CbMutateGene, null);

    //=========================================== World ======
    // Init UI data
    ChoicePop.add(Integer.toString(CGavUniverse.TabPop[0]));
    ChoicePop.add(Integer.toString(CGavUniverse.TabPop[2]));
    ChoicePop.add(Integer.toString(CGavUniverse.TabPop[4]));
    ChoicePop.add(Integer.toString(CGavUniverse.TabPop[6]));
    ChoicePop.add(Integer.toString(CGavUniverse.TabPop[8]));
    ChoicePop.add(Integer.toString(CGavUniverse.TabPop[10]));
    ChoiceSpeed.add("5");
    ChoiceSpeed.add("25");
    ChoiceSpeed.add("100");
    ChoiceSpeed.add("1000");
    // Creates the World with Biomorphs
    World=new CGavUniverse(this);
    // Add views
    panel1.add(World.MainView,null);
    PanDispGen1.add(World.ViewGene1,null);
    PanDispGen2.add(World.ViewGene2,null);
    PanDispGen3.add(World.ViewGene3,null);
    PanDispMaxFit.add(World.ViewMaxFit,null);
    PanDispAvgFit.add(World.ViewAvgFit,null);
    PanDispBitGen1.add(World.ViewGoalBitGen,null);
    PanDispBitGen2.add(World.ViewCurrentBitGen,null);
    panel6.add(panel9, null);
    panel9.add(PanDispGen1, null);
    panel9.add(PanDispGen2, null);
    panel9.add(PanDispGen3, null);
    this.add(panel10, BorderLayout.SOUTH);
    panel10.add(panel15, null);
    panel15.add(PanDispBitGen1, null);
    panel15.add(PanDispBitGen2, null);
    panel10.add(panel11, null);
    panel11.add(panel8, null);
    panel8.add(FitBestGene, null);
    panel11.add(PanDispMaxFit, null);
    panel11.add(panel12, null);
    panel12.add(FitAvgGene, null);
    panel11.add(PanDispAvgFit, null);
    this.add(panel13, BorderLayout.NORTH);

    panel13.add(panel3, null);
    panel3.add(ButtonRandom, null);
    panel3.add(ButtonStep, null);
    panel3.add(ButtonGo, null);
    panel3.add(panel2, null);
    panel2.add(ButtonGridPlus, null);
    panel2.add(ButtonGrid0, null);
    panel2.add(ButtonGridLess, null);
    panel3.add(panel16, null);
    panel13.add(panel14, null);
    panel14.add(LabTextOut, null);

    panel16.add(ButtonDefault, null);
    panel16.add(ButtonAbout, null);

    InitDefaultParam();
  }

  /** Init the World */
  public void start() {
    World.InitView();
    World.DrawWorld();
  }

  /** Resizing management */
  void this_componentResized(ComponentEvent e) {
    boolean isr=false;
    if(World.IsRunning) {
      synchronized(World) {World.stop();}
      isr=true;
    }
    World.InitView();
    World.DrawWorld();
    if(isr) {
      ButtonGo.setLabel(Texts.Txt[22]);
      World.LaunchResearch();
    }
  }

  /** Step */
  void ButtonStep_actionPerformed(ActionEvent e) {
    if(!World.IsInit) {
      SetBasicParam();
      ChoicePop.enable(false);
      MutationRate.enable(false);
      World.InitResearch(ParamMr);
    }
    else
      World.Go();
      if(!World.SolFound)
        LabTextOut.setText(Texts.Txt[24]);
  }

  /** Lauch the genetic research */
  void ButtonGo_actionPerformed(ActionEvent e) {
    if(World.IsRunning) {
      LabTextOut.setText(Texts.Txt[24]);
      World.stop();
      ButtonRandom.setLabel(Texts.Txt[0]);
      ButtonGo.setLabel(Texts.Txt[2]);
      ButtonStep.enable(true);
      ButtonDefault.enable(true);
    }
    else {
      LabTextOut.setText(Texts.Txt[25]);
      ButtonRandom.setLabel(Texts.Txt[1]);
      if(!World.IsInit) {
        SetBasicParam();
        ChoicePop.enable(false);
        MutationRate.enable(false);
        World.InitResearch(ParamMr);
      }
      ButtonGo.setLabel(Texts.Txt[22]);
      ButtonStep.enable(false);
      ButtonDefault.enable(false);
      World.LaunchResearch();
    }
  }

  /** Generate Random Bioms e.g. a completly new set of pop if world is
  not running, or a new working set if world is running. */
  void ButtonRandom_actionPerformed(ActionEvent e) {
    if(!World.IsRunning) {
      LabTextOut.setText(Texts.Txt[23]);
      ButtonStep.enable(true);
      ChoicePop.enable(true);
      ButtonGo.enable(true);
      MutationRate.enable(true);
      World.InitWorld();
      World.DrawWorld();
    }
    else {
      World.GenInitPop();
      World.DrawWorld();
    }
  }

  /** Display About box */
  void ButtonAbout_mouseClicked(MouseEvent e) {
    CGavAbout Box=new CGavAbout(this,MotherApplet.GetName(),true);
    Dimension dim= getToolkit().getScreenSize();
    Box.setSize(dim.width/4,dim.height/3);
    Box.setLocation(this.getLocation().x+(this.getSize().width/2)-
        (Box.getSize().width/2),dim.height/2-Box.getSize().height/2);
    Box.show();
  }

  /** Modification of Elitist Selection flag */
  void CbElitist_itemStateChanged(ItemEvent e) {
    World.SetElitistSel(CbElitist.getState());
  }
  /** Modification of scaling type */
  void CbScaleWindow_itemStateChanged(ItemEvent e) {
    if(CbScaleWindow.getState())
      World.SetScalingType(World.SCALEWINDOW);
  }
  void CbScaleExpo_itemStateChanged(ItemEvent e) {
    if(CbScaleExpo.getState())
      World.SetScalingType(World.SCALEEXPO);
  }
  void CbScaleLinear_itemStateChanged(ItemEvent e) {
    if(CbScaleLinear.getState())
      World.SetScalingType(World.SCALELINEAR);
  }
  void CbScaleLinear2_itemStateChanged(ItemEvent e) {
    if(CbScaleLinear2.getState())
      World.SetScalingType(World.SCALELINEAR2);
  }
  void CbNoScaling_itemStateChanged(ItemEvent e) {
    if(CbNoScaling.getState())
      World.SetScalingType(World.SCALENONE);
  }
  /** Modification of mutation type */
  void CbMutateBit_itemStateChanged(ItemEvent e) {
    World.SetMutationType(!CbMutateBit.getState());
  }
  void CbMutateGene_itemStateChanged(ItemEvent e) {
    World.SetMutationType(CbMutateGene.getState());
  }
  /** Modification of Fitness calc type */
  void CbCalcTypeGeno_itemStateChanged(ItemEvent e) {
    World.SetGenCalcType(CbCalcTypeGeno.getState());
  }
  void CbCalcTypePheno_itemStateChanged(ItemEvent e) {
    World.SetGenCalcType(!CbCalcTypePheno.getState());
  }
  /** Stop */
  void stop() {
    if(World.SolFound) {
      LabTextOut.setText(Texts.Txt[26]);
      ChoicePop.enable(true);
      ButtonGo.enable(true);
      ButtonStep.enable(true);
      ButtonDefault.enable(true);
      MutationRate.enable(true);
      ButtonRandom.setLabel(Texts.Txt[0]);
    }
    ButtonGo.setLabel(Texts.Txt[2]);
  }
  /** Good-Bye */
  void this_windowClosing(WindowEvent e) {
    End();
  }
  /** End */
  void End() {
    synchronized(World) {World.end();}
    dispose();
  }
  // Parameters management
  /** Set Speed */
  void ChoiceSpeed_itemStateChanged(ItemEvent e) {
    World.SetSpeed(Integer.parseInt(ChoiceSpeed.getSelectedItem()));
  }
  /** Population change */
  void ChoicePop_itemStateChanged(ItemEvent e) {
    SetPop();
    LabTextOut.setText(Texts.Txt[23]);
  }
  /** Set a new population size. */
  void SetPop() {
    World.SetPopSize(Integer.parseInt(ChoicePop.getSelectedItem())+1);
    int selpop=ChoicePop.getSelectedIndex();
    MutationRate.setText(Integer.toString(CGavUniverse.TabPop[selpop*2+1]));

    World.InitWorld();

    SetGrid(ChoicePop.getSelectedIndex()+2);
    CurrentGrid=World.MainView.GetGrid();
    World.DrawWorld();
  }

  /** Increase the # of cells */
  void ButtonGridPlus_actionPerformed(ActionEvent e) {
    ButtonGridLess.enable(true);
    SetGrid(World.GetMainView().GetGrid()+1);
    World.DrawWorld();
  }
  /** Decrease the # of cells */
  void ButtonGridLess_actionPerformed(ActionEvent e) {
    ButtonGridPlus.enable(true);
    SetGrid(World.GetMainView().GetGrid()-1);
    World.DrawWorld();
  }
  /** Set Grid according to current pop */
  void ButtonGrid0_actionPerformed(ActionEvent e) {
    SetGrid(CurrentGrid);
    World.DrawWorld();
  }
  /** Set Grid */
  void SetGrid(int crt) {
    World.SetGrid(crt);
    if(crt==CGavView.MAXGRID)
      ButtonGridPlus.enable(false);
    else
      ButtonGridPlus.enable(true);
    if(crt==1)
      ButtonGridLess.enable(false);
    else
      ButtonGridLess.enable(true);
  }
  /** restore default param*/
  void ButtonDefault_actionPerformed(ActionEvent e) {
    InitDefaultParam();
    SetPop();
  }
  /** Set Default Param */
  void InitDefaultParam() {
    LabTextOut.setText(Texts.Txt[23]);
    MutationRate.setText(Integer.toString(CGavUniverse.TabPop[CGavUniverse.DefaultPopIdx*2+1]));
    ChoiceSpeed.select(Integer.toString(CGavUniverse.DefaultSpeed));
    ChoicePop.select(Integer.toString(CGavUniverse.TabPop[CGavUniverse.DefaultPopIdx*2]));
    CbElitist.setState(CGavUniverse.DefaultElitistSel);
    CbCalcTypeGeno.setState(CGavUniverse.DefaultGenCalcType);
    CbCalcTypePheno.setState(!CGavUniverse.DefaultGenCalcType);
    CbMutateGene.setState(CGavUniverse.DefaultMutateGene);
    CbMutateBit.setState(!CGavUniverse.DefaultMutateGene);
    switch(CGavUniverse.DefaultScalingType) {
      case CGavUniverse.SCALEEXPO :
        CbScaleExpo.setState(true);
        break;
      case CGavUniverse.SCALELINEAR :
        CbScaleLinear.setState(true);
        break;
      case CGavUniverse.SCALELINEAR2 :
        CbScaleLinear2.setState(true);
        break;
      case CGavUniverse.SCALENONE :
        CbNoScaling.setState(true);
        break;
      case CGavUniverse.SCALEWINDOW :
        CbScaleWindow.setState(true);
        break;
    }
    ButtonStep.enable(true);
    ChoicePop.enable(true);
    ButtonGo.enable(true);
    MutationRate.enable(true);
    World.InitDefaultWorld();
  }
  /** Set Basic Parameters : Mutation rate. */
  void SetBasicParam() {
    try {
      ParamMr=Integer.parseInt(MutationRate.getText());
    } catch(Exception ex) {
        ParamMr=CGavUniverse.TabPop[CGavUniverse.DefaultPopIdx*2+1];
    }
    if(ParamMr<0)
      ParamMr=0;
    MutationRate.setText(""+ParamMr);
  }
  /** Disable Run */
  void DisableRun() {
    ButtonDefault.enable(false);
    ButtonGo.enable(false);
    ButtonGrid0.enable(false);
    ButtonGridLess.enable(false);
    ButtonGridPlus.enable(false);
    ButtonRandom.enable(false);
    ButtonStep.enable(false);
    ChoicePop.enable(false);
  }
  /** Enable Run */
  void EnableRun(){
    ButtonDefault.enable(true);
    ButtonGo.enable(true);
    ButtonGrid0.enable(true);
    ButtonGridLess.enable(true);
    ButtonGridPlus.enable(true);
    ButtonRandom.enable(true);
    ButtonStep.enable(true);
    if(!World.IsInit || World.SolFound==true)
      ChoicePop.enable(true);
  }
}


