//***************************************************************************
//  Genetic Algorithm Viewer 1.0
//    26/5/2000
//
//  This program uses a GA to find a Biomorph Genome
//    Jean-Philippe Rennard May 2000
//    alife@rennard.org
//    http://www.rennard.org/alife
//
//    This program is free software; you can redistribute it and/or
//    modify it under the terms of the GNU General Public License
//    as published by the Free Software Foundation.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//***************************************************************************
package Gav;

import java.awt.*;
import java.awt.event.*;
import java.applet.*;

/** Browser interface for GAV */
public class Gav extends Applet {
  static final int LANGFR=0;
  static final int LANGEN=1;

  int Language=0;
  boolean isStandalone = false;
  GridLayout gridLayout1 = new GridLayout();
  Button button1 = new Button();

  CGavApp GavApp;
  //Construire l'applet
  public Gav() {
  }

  //Initialiser l'applet
  public void init() {
    try { Language = Integer.parseInt(getParameter("Language", ""));
    } catch (Exception e) { e.printStackTrace(); }
    try  {
      jbInit();
    }
    catch(Exception e)  {
      e.printStackTrace();
    }
  }

  /**Component Init. */
  private void jbInit() throws Exception {
    if(Language==LANGEN)
      button1.setLabel("Push to lauch applet");
    else
      button1.setLabel("Appuyez pour lancer l'applet");
    button1.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        button1_actionPerformed(e);
      }
    });
    this.setLayout(gridLayout1);
    this.add(button1, null);
//    GavApp=new CGavApp(this);
  }

  public String getAppletInfo() {
    return "Information applet";
  }

  //Obtenir une valeur de paramtre
  public String getParameter(String key, String def) {
    return isStandalone ? System.getProperty(key, def) :
      (getParameter(key) != null ? getParameter(key) : def);
  }


  public String[][] getParameterInfo() {
    return null;
  }

  public String GetVersionNum() {
    return("1.1-21/05/2000");
  }

  public String GetName() {
    return("Genetic Algorithm Viewer");
  }

  public String GetAuthor() {
    return("Jpr.");
  }
  public String GetInfos() {
    return(
      "\nGenetic Algorithm Applet\n"+
      "Copyright(c) Jpr. 04/2000\n\n"+
      "www.rennard.org/alife"+"\n"+
      "alife@rennard.org");
  }
  /** Launch GAV App */
  void button1_actionPerformed(ActionEvent e) {
    GavApp=new CGavApp(this,Language);
    Dimension dim= getToolkit().getScreenSize();
    GavApp.setSize((int)(0.75*dim.width),(int)(0.75*dim.height));
//    GavApp.setSize(640,480);
//    GavApp.setSize(800,600);
//    GavApp.setLocation(dim.width/2-GavApp.getSize().width/2,
//            dim.height/2-GavApp.getSize().height/2);
      GavApp.setLocation(20,20);  // Or doesn't work properly under Linux !
    GavApp.show();
    GavApp.start();
  }

  public void destroy() {
    if(GavApp!=null)
      GavApp.End();
  }
}
